import java.io.*;

public class FileConvert {
  static final int MAXFILESIZE = 1000000; // max ~ 1MB

  public static void convert(InputStream inStream, String inType,
			OutputStream outStream, String outType) throws IOException {
    char[] chars = new char[MAXFILESIZE];
    InputStreamReader in = new InputStreamReader(inStream, inType);
    OutputStreamWriter out = new OutputStreamWriter(outStream, outType);
    int numChars = in.read(chars, 0, MAXFILESIZE);
    System.out.println("read " + numChars);
    out.write(chars, 0, numChars);
    out.flush();
  }

  /*
  public static void writeHex(InputStream inStream, String inType) throws IOException {
    char[] chars = new char[MAXFILESIZE];
    InputStreamReader in = new InputStreamReader(inStream, inType);
    int numChars = in.read(chars, 0, MAXFILESIZE);
    byte[] bytes = (new String(chars, 0, numChars)).getBytes();
    // print the bytes as hex
    int nibble;
    for (int i=0; i<bytes.length; i++) {
      System.out.println(Integer.toHexString(bytes[i]));
    }
  }
  */

  public static void writeHex(FileInputStream inStream) throws IOException {
    byte[] bytes = new byte[MAXFILESIZE];
    int numBytes = inStream.read(bytes);
    // print the bytes as hex
    for (int i=0; i<numBytes; i++) {
      if ((bytes[i] & (byte)0x80) != (byte)0) { // negative value
	int b = bytes[i] & (byte)0x7f; // remove sign bit to later form unsigned value
	System.out.println(Integer.toHexString(b + 0x0080)); // add sign bit back
      }
    else // positive
      System.out.println(Integer.toHexString(bytes[i]));
    }
  }

  public static void main(String args[]) {
    try {
      FileInputStream fin = new FileInputStream(args[0]);
      /*
      FileInputStream fin = new FileInputStream(args[0]);
      FileOutputStream fout = new FileOutputStream(args[2]);
      convert(fin, args[1], fout, args[3]);
      fin.close();
      fout.close();
      */
      //writeHex(fin, "Unicode");
      writeHex(fin);
    }
    catch(IOException ioe) {
      Tools.perr(ioe);
    }
  }

}
