public class JIS {

/* I grabbed this from the jwp source and converted it to Java   */

/* The following routine came from KD, the Kanji Driver program  */
/* written by Izumi Ozawa.  It was reformatted and slightly      */
/* modified.  Many thanks to Izumi for his donation.             */

  public JIS() {}

  public static byte HIBYTE(byte bytes[]) {
    return bytes[0];
  }

  public static byte LOBYTE(byte bytes[]) {
    return bytes[1];
  }

  public static long Jis2Index (byte jiscode[], boolean holes) {
    long hi, lo;

    hi = (long) (HIBYTE(jiscode) & (byte)0x7f);
    lo = (long) (LOBYTE(jiscode) & (byte)0x7f);


    if (lo <= 0x20 || lo >= 0x7f || hi <= 0x20 || hi >= 0x75)
        return (-1);

    if (hi == 0x74 && lo > 0x24) return (-1);

    hi = 94 * (hi - 33) + (lo - 33);

    if (holes) return (hi);


    /* Skip the holes */

    if (hi <= 107)
        return (hi);        /* 0..93               $2121-$217e, 0  -93   */
                            /* 94..107             $2221-$222e, 94 -107  */
    else if (hi >= 203 && hi <= 212)
        return (hi - 56);   /* 203..212   0 .. 9,  $2330-$2339, 147-156  */
    else if (hi >= 220 && hi <= 245)
        return (hi - 63);   /* 220..245   A .. Z,  $2341-$235a, 157-182  */
    else if (hi >= 252 && hi <= 277)
        return (hi - 69);   /* 252..277   a .. z,  $2361-$237a, 183-208  */
    else if (hi >= 282 && hi <= 364)
        return (hi - 73);   /* 282..364  hiragana, $2421-$2473, 209-291  */
    else if (hi >= 376 && hi <= 461)
        return (hi - 84);   /* 376..461  katakana, $2521-$2576, 292-377  */
    else if (hi >= 470 && hi <= 493)
        return (hi - 92);   /* 470..493   GREEK,   $2621-$2638, 378-401  */
    else if (hi >= 502 && hi <= 525)
        return (hi - 100);  /* 502..525   greek,   $2641-$2658, 402-425  */
    else if (hi >= 564 && hi <= 596)
        return (hi - 138);  /* 564..596   RUSSIAN, $2721-$2741, 426-458  */
    else if (hi >= 612 && hi <= 644)
        return (hi - 153);  /* 612..644   russian, $2751-$2771, 459-491  */
                            /*  n/a       linedraw,  n/a      , 492-523  */
    else if (hi >= 1410 && hi <= 4374)
        return (hi - 886);  /* 1410..4374 kanji-1, $3021-$4f53, 524-3488 */
    else if (hi >= 4418 && hi <= 7805)
        return (hi - 928);  /* 4418..7805 kanji-2, $5021-$7424, 3490-6877 */

    /* No such kanji */

    return (-1);
}

}
